const nodeFetch = require('node-fetch');

const fetchReconnect = function (...args) {
  return new Promise(async resolve => {
    const request = typeof fetch === 'undefined' ? nodeFetch : fetch;
    const delay = 5000;

    try {
      const res = await request(...args);
      resolve(res);
    } catch (error) {
      const timerId = setTimeout(async function cb() {
        try {
          const res = await request(...args);
          clearTimeout(timerId);
          resolve(res);
          console.log('connected to requested API');
        } catch (e) {
          console.log('Attempt to connect requested API');
          setTimeout(cb, delay);
        }
      }, delay);
      console.log(error.message);
    }
  });
};

module.exports = fetchReconnect;