const nodeFetch = require('node-fetch');

const fetchReconnect = function (...args) {
  return new Promise(async resolve => {
    const request = typeof fetch === 'undefined' ? nodeFetch : fetch;
    const delay = 5000;

    try {
      const res = await request(...args);
      resolve(res);
    } catch (error) {
      const timerId = setTimeout(async function bar() {
        try {
          const res = await request(...args);
          clearTimeout(timerId);
          resolve(res);
        } catch (error) {
          console.log(error.message, 'Attempt to connect requested API');
          setTimeout(bar, delay);
        }
      }, delay);
    }
  });
};

module.exports = fetchReconnect;